



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>android可拖动排序GridView实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">android可拖动排序GridView实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 02:59:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>经常使用今日头条、网易新闻的同学们应该都会注意到用于管理多个频道的可拖动排序GridView，下面介绍一下可拖动的DragGridView的实现方法。代码放在GitHub上https://github.com/zhaoyu87/DragGridView，需要的同学可以下载</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/726738/201503/082325016498400.jpg" /></p>
<p>DragGridView继承自GridView，当长按选中某个item进行拖动，放手更新GridView顺序：</p>
<p>1.重写onTouchEvent响应拖动事件：被按下时记录按下坐标；拖动时更新被拖动视图显示；放开时更新排序</p>
<p>2.设置OnItemLongClickListener：响应长按选取拖动item，获取被选中item bitmap，添加到窗口显示</p>
<p>3.通过view.getDrawingCache()获取被选中item的bitmap，用于绘制拖动的view</p>
<p>4.使用WindowManager来向窗口添加view，更新view显示。关于WindowManagerService对窗口的组织方式，博客http://blog.csdn.net/luoshengyang/article/details/8498908有介绍，可以参考。</p>
<p>5.&nbsp;MotionEvent中的getX()为相对于容器的坐标，这里就是GridView；getRawX()为相对于整个屏幕的坐标</p>
<p>DragGridView实现如下，注释中有更详细的解释</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">  1 public class DragGridView extends GridView {<br />
  2     private static final int DRAG_IMG_SHOW = 1;<br />
  3     private static final int DRAG_IMG_NOT_SHOW = 0;<br />
  4     private static final String LOG_TAG = "DragGridView";<br />
  5     private static final float AMP_FACTOR = 1.2f;<br />
  6<br />
  7     /**被拖动的视图*/<br />
  8     private ImageView dragImageView;<br />
  9     private WindowManager.LayoutParams dragImageViewParams;<br />
 10     private WindowManager windowManager;<br />
 11     private boolean isViewOnDrag = false;<br />
 12<br />
 13     /**前一次拖动的位置*/<br />
 14     private int preDraggedOverPositon = AdapterView.INVALID_POSITION;<br />
 15     private int downRawX;<br />
 16     private int downRawY;<br />
 17<br />
 18     /**长按选中拖动item*/<br />
 19     private OnItemLongClickListener onLongClickListener = new OnItemLongClickListener(){<br />
 20<br />
 21         @Override<br />
 22         //长按item开始拖动<br />
 23         public boolean onItemLongClick(AdapterView&lt;?&gt; parent, View view, int position, long id) {<br />
 24<br />
 25             //记录长按item位置<br />
 26             preDraggedOverPositon = position;<br />
 27<br />
 28             //获取被长按item的drawing cache<br />
 29             view.destroyDrawingCache();<br />
 30             view.setDrawingCacheEnabled(true);<br />
 31             //通过被长按item，获取拖动item的bitmap<br />
 32             Bitmap dragBitmap = Bitmap.createBitmap(view.getDrawingCache());<br />
 33<br />
 34             //设置拖动item的参数<br />
 35             dragImageViewParams.gravity = Gravity.TOP | Gravity.LEFT;<br />
 36             //设置拖动item为原item 1.2倍<br />
 37             dragImageViewParams.width = (int)(AMP_FACTOR*dragBitmap.getWidth());<br />
 38             dragImageViewParams.height = (int)(AMP_FACTOR*dragBitmap.getHeight());<br />
 39             //设置触摸点为绘制拖动item的中心<br />
 40             dragImageViewParams.x = (downRawX - dragImageViewParams.width/2);<br />
 41             dragImageViewParams.y = (downRawY - dragImageViewParams.height/2);<br />
 42             dragImageViewParams.flags = WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE<br />
 43                                         | WindowManager.LayoutParams.FLAG_NOT_TOUCHABLE<br />
 44                                         | WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON<br />
 45                                         | WindowManager.LayoutParams.FLAG_LAYOUT_IN_SCREEN;<br />
 46             dragImageViewParams.format = PixelFormat.TRANSLUCENT;<br />
 47             dragImageViewParams.windowAnimations = 0;<br />
 48<br />
 49             //dragImageView为被拖动item的容器，清空上一次的显示<br />
 50             if((int)dragImageView.getTag() == DRAG_IMG_SHOW) {<br />
 51                 windowManager.removeView(dragImageView);<br />
 52                 dragImageView.setTag(DRAG_IMG_NOT_SHOW);<br />
 53             }<br />
 54<br />
 55             //设置本次被长按的item<br />
 56             dragImageView.setImageBitmap(dragBitmap);<br />
 57<br />
 58             //添加拖动item到屏幕<br />
 59             windowManager.addView(dragImageView, dragImageViewParams);<br />
 60             dragImageView.setTag(DRAG_IMG_SHOW);<br />
 61             isViewOnDrag = true;<br />
 62<br />
 63             //设置被长按item不显示<br />
 64             ((GridViewAdapter)getAdapter()).hideView(position);<br />
 65             return true;<br />
 66         }<br />
 67     };<br />
 68<br />
 69     public DragGridView(Context context) {<br />
 70         super(context);<br />
 71         initView();<br />
 72     }<br />
 73<br />
 74     public DragGridView(Context context, AttributeSet attrs) {<br />
 75         super(context, attrs);<br />
 76         initView();<br />
 77     }<br />
 78<br />
 79     public DragGridView(Context context, AttributeSet attrs, int defStyleAttr) {<br />
 80         super(context, attrs, defStyleAttr);<br />
 81         initView();<br />
 82     }<br />
 83<br />
 84     public void initView() {<br />
 85         setOnItemLongClickListener(onLongClickListener);<br />
 86         //初始化显示被拖动item的image view<br />
 87         dragImageView = new ImageView(getContext());<br />
 88         dragImageView.setTag(DRAG_IMG_NOT_SHOW);<br />
 89         //初始化用于设置dragImageView的参数对象<br />
 90         dragImageViewParams = new WindowManager.LayoutParams();<br />
 91         //获取窗口管理对象，用于后面向窗口中添加dragImageView<br />
 92         windowManager = (WindowManager) getContext().getSystemService(Context.WINDOW_SERVICE);<br />
 93     }<br />
 94<br />
 95<br />
 96     @Override<br />
 97     public boolean onTouchEvent(MotionEvent ev) {<br />
 98<br />
 99         //被按下时记录按下的坐标<br />
100         if(ev.getAction() == MotionEvent.ACTION_DOWN) {<br />
101             //获取触摸点相对于屏幕的坐标<br />
102             downRawX = (int)ev.getRawX();<br />
103             downRawY = (int)ev.getRawY();<br />
104         }<br />
105         //dragImageView处于被拖动时，更新dragImageView位置<br />
106         else if((ev.getAction() == MotionEvent.ACTION_MOVE) &amp;&amp; (isViewOnDrag == true)) {<br />
107             Log.i(LOG_TAG, "" + ev.getRawX() + " " + ev.getRawY());<br />
108             //设置触摸点为dragImageView中心<br />
109             dragImageViewParams.x = (int)(ev.getRawX() - dragImageView.getWidth()/2);<br />
110             dragImageViewParams.y = (int)(ev.getRawY() - dragImageView.getHeight()/2);<br />
111             //更新窗口显示<br />
112             windowManager.updateViewLayout(dragImageView, dragImageViewParams);<br />
113             //获取当前触摸点的item position<br />
114             int currDraggedPosition = pointToPosition((int)ev.getX(), (int)ev.getY());<br />
115             //如果当前停留位置item不等于上次停留位置的item，交换本次和上次停留的item<br />
116             if((currDraggedPosition != AdapterView.INVALID_POSITION) &amp;&amp; (currDraggedPosition != preDraggedOverPositon)) {<br />
117                 ((GridViewAdapter)getAdapter()).swapView(preDraggedOverPositon, currDraggedPosition);<br />
118                 preDraggedOverPositon = currDraggedPosition;<br />
119             }<br />
120         }<br />
121         //释放dragImageView<br />
122         else if((ev.getAction() == MotionEvent.ACTION_UP) &amp;&amp; (isViewOnDrag == true)) {<br />
123             ((GridViewAdapter)getAdapter()).showHideView();<br />
124             if((int)dragImageView.getTag() == DRAG_IMG_SHOW) {<br />
125                 windowManager.removeView(dragImageView);<br />
126                 dragImageView.setTag(DRAG_IMG_NOT_SHOW);<br />
127             }<br />
128             isViewOnDrag = false;<br />
129         }<br />
130         return super.onTouchEvent(ev);<br />
131     }<br />
132 }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>GridViewAdapter继承自BaseAdapter：</p>
<p>1.提供showHideView、hideView两个方法用于显示和隐藏选中Item的Text</p>
<p>2.提供swapView方法用于拖动过程中更新GridView中item显示</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1 public class GridViewAdapter extends BaseAdapter {<br />
 2     private Context context;<br />
 3     private List&lt;String&gt; strList;<br />
 4     private int hidePosition = AdapterView.INVALID_POSITION;<br />
 5<br />
 6     public GridViewAdapter(Context context, List&lt;String&gt; strList) {<br />
 7         this.context = context;<br />
 8         this.strList = strList;<br />
 9     }<br />
10<br />
11     @Override<br />
12     public int getCount() {<br />
13         return strList.size();<br />
14     }<br />
15<br />
16     @Override<br />
17     public String getItem(int position) {<br />
18         return strList.get(position);<br />
19     }<br />
20<br />
21     @Override<br />
22     public long getItemId(int position) {<br />
23         return position;<br />
24     }<br />
25<br />
26     @Override<br />
27     public View getView(int position, View convertView, ViewGroup parent) {<br />
28         TextView view;<br />
29         if(convertView == null) {<br />
30             view = new TextView(context);<br />
31         }<br />
32         else {<br />
33             view = (TextView)convertView;<br />
34         }<br />
35<br />
36         //hide时隐藏Text<br />
37         if(position != hidePosition) {<br />
38             view.setText(strList.get(position));<br />
39         }<br />
40         else {<br />
41             view.setText("");<br />
42         }<br />
43         view.setId(position);<br />
44<br />
45         return view;<br />
46     }<br />
47<br />
48     public void hideView(int pos) {<br />
49         hidePosition = pos;<br />
50         notifyDataSetChanged();<br />
51     }<br />
52<br />
53     public void showHideView() {<br />
54         hidePosition = AdapterView.INVALID_POSITION;<br />
55         notifyDataSetChanged();<br />
56     }<br />
57<br />
58     public void removeView(int pos) {<br />
59         strList.remove(pos);<br />
60         notifyDataSetChanged();<br />
61     }<br />
62<br />
63     //更新拖动时的gridView<br />
64     public void swapView(int draggedPos, int destPos) {<br />
65         //从前向后拖动，其他item依次前移<br />
66         if(draggedPos &lt; destPos) {<br />
67             strList.add(destPos+1, getItem(draggedPos));<br />
68             strList.remove(draggedPos);<br />
69         }<br />
70         //从后向前拖动，其他item依次后移<br />
71         else if(draggedPos &gt; destPos) {<br />
72             strList.add(destPos, getItem(draggedPos));<br />
73             strList.remove(draggedPos+1);<br />
74         }<br />
75         hidePosition = destPos;<br />
76         notifyDataSetChanged();<br />
77     }<br />
78 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlxykqo.html">Android开发学习之路-动态高斯模糊怎么做</a>
		</li>
						<li><a href="https://www.batexi.com/a/49glx4lq.html">细胞分裂（codevs 2952）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnnr4oq.html">小韦XP 和win2003装电信天翼3G无线上网卡</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y67mjq.html">Activiti 工作流会签开发设计思路</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnzko0q.html">FZU 2092 收集水晶 dp&plus;bfs</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ox74n9.html">三星S5驱动安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eymlrj9.html">jqGrid使用整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpkr379.html">201521123077 《Java程序设计》第3周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjzloz8.html">C&num;中的Explicit和Implicit</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv27x38.html">nginx使用https协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m21jz0q.html">数据仓库专题18-数据建模语言IDEF（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwlyek8.html">外网访问内网的FTP服务器-原理解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k5lx3q.html">Vue 的开始</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveeg7o9.html">好用的图片缩放JS</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kgjm3q.html">Spring JdbcTemplate详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kzx4wq.html">&OpenCurlyDoubleQuote;全栈2019&rdquo;Java多线程第十二章：后台线程setDaemon&lpar;&rpar;方法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r40ze78.html">接口测试框架开发（三）：maven&plus;restAssured&plus;Excel（jxl）&plus;testng&plus;extentreports的接口自动化</a>
		</li>
						<li><a href="https://www.batexi.com/a/90dkokm8.html">UVA 1593 Alignment of Code（紫书习题5-1 字符串流）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy2nokm9.html">YUV转换成RGB算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95p1gnmq.html">未能加载文件或程序集&OpenCurlyDoubleQuote;Interop&period;SQLDMO&rdquo;或它的某一个依赖项</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gmlxke9.html">HttpContext&period;Current&period;Cache 过期时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydpopgq.html">Annotation 与 HttpClient（5）--Annotation HttpClient</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdo3ge8.html">Floyd算法应用-医院选址问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x5l309.html">Guava缓存器源码分析&mdash;&mdash;缓存统计器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m4vyeq.html">多校联合练习赛1 Problem1005 Deque LIS&plus;LDS 再加一系列优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1wgo59.html">AngularJS初始用之 中间件 connect &period;static 静态文件不能找到</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1ze7v09.html">android的Log日志打印管理工具类&lpar;一&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mng0xpq.html">JAVA Stop The World 第八节</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn1v7z8.html">TCP&sol;IP的三次握手协议</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn13pxk8.html">Linux学习之echo命令</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
